/* PELDA20.C: Valos szamok atlaga, s az ez alatti, ill.
              feletti elemek szama. */
#include <stdio.h>
#include <stdlib.h> /* Az atof miatt! */
#define INP 60      /* Az input puffer merete. */
int getline(char s[],int lim){
  int c,i;
  for(i=0;i<lim&&(c=getchar())!=EOF&&c!='\n';++i)s[i]=c;
  s[i]='\0';
  while(c!=EOF && c!='\n') c=getchar();
  return(i); }
#include <ctype.h>
int lebege(char s[]){
  int i=0, kezd;
  /* Feher karakterek atlepese a lanc elejen: */
  while(isspace(s[i])) ++i;
  /* A mantissza elojele: */
  if(s[i]=='+'||s[i]=='-') ++i;
  kezd=i; /* A szamjegyek itt kezdodnek. */
  /* A mantissza egesz resze: */
  while(isdigit(s[i])) ++i;
  /* A mantissza tort resze: */
  if(s[i]=='.') ++i;
  while(isdigit(s[i])) ++i;
  /* Nincs szamjegy, vagy csak egy . van: */
  if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
  /* Kitevo resz: */
  if(toupper(s[i])=='E'){
    ++i;
    if(s[i]=='+'||s[i]=='-')++i;
    /* Egy szamjegynek lennie kell a kitevoben! */
    if(!isdigit(s[i])) return 0;
    while(isdigit(s[i])) ++i;}
  /* Vege: */
  if(isspace(s[i])||!s[i]) return 1;
  else return 0; }
#include <float.h>
double gyujto(double a){
  static double ossz=0.0;
  if(a<0.0&&-(DBL_MAX+a)<ossz || DBL_MAX-a>ossz)
    ossz+=a;
  return ossz; }
#include "dverem.h"
void main(void){
  int max=clear(),/* A verem max. merete. */
      i=0, alatt, felett;
  char s[INP+1]; /* Az input puffer. */
  double a;
  printf("Szamsorozat atlaga alatti s feletti "
         "elemeinek szama.\nA megadast ures "
         "sorral kell befejezni!\n\n");
  while(printf("%4d. elem: ", i+1), i<max &&
    getline(s,INP)>0)
    if(lebege(s)){
      push(a=atof(s));
      printf("Az osszeg:%30.6f\n\n", a=gyujto(a));
      ++i;}
    printf("\nAz atlag: %30.6f\n", a/=i);
    for(max=alatt=felett=0; max<i; ++max){
      double b=pop();
      if(b<a) ++alatt;
      else if(b>a) ++felett; }
    printf("Az atlag alattiak szama: %8d.\n"
           "Az atlag felettiek szama:%8d.\n",
           alatt, felett); }

