/* PELDA22.C: Rekurzios peldaprogram: faktorialis. */
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#define MAX 40 /* Az input puffer merete. */
int getline(char s[],int n){
  int c,i;
  for(i=0;i<n&&(c=getchar())!=EOF&&c!='\n';++i) s[i]=c;
  s[i]='\0';
  while(c!=EOF&&c!='\n') c=getchar();
  return(i); }
/* A decimalis szamjegyek szama maximalisan: */
#define HSZ sizeof(int)/sizeof(short)*5
int egesze(char s[]){
  int i = 0, kezd; 
  /* A karakterlanc eleji feher karakterek atlepese: */
  while(s[i]==' ' || s[i]=='\n' || s[i]=='\t') ++i;
  /* Az elojel atlepese: */
  if(s[i]=='+' || s[i]=='-') ++i;
  kezd=i; /* A szamjegyek itt kezdodnek. */
  /* Elore a kovetkezo nem numerikus karakterre: */
  while(s[i]>='0' && s[i]<='9' && i-kezd<HSZ) ++i;
  /* Dontes: */
  if(kezd==i || s[i]!='\n' && s[i]!='\t' &&
     s[i]!=' ' && s[i]!=0) return 0;
  else return 1; }
long double faktorialis(int n){
  if(n==0||n==1) return 1.L;
  else return (n*faktorialis(n-1)); }
void main(void){
  int n=0; /* A szm. */
  char sor[MAX+1]; /* Input puffer. */
  printf("\t\tRekurziot szemlelteto peldaprogram.\n");
  while(n<1||n>MAX){
    printf("\nMelyik egesz szam faktorialisat szamitsuk?(1-%d)? ",MAX);
    getline(sor,MAX);
    if(egesze(sor)) n=atoi(sor);}
  printf("\nA rekurzioval eloallitott ertek:\n %6d! = %-10.0Lf \n",
         n, faktorialis(n)); }

