/* PELDA21.C: Datumellenorzes. */
#include <stdio.h>
#include <stdlib.h> /* Az atoi miatt! */
#define INP 11      /* Az input puffer merete. */
#include <ctype.h>  /* Az isdigit miatt! */
int datume(const char []);
int getline(char [], int);
void main(void){
  char s[INP+1]; /* Az input puffer. */
  printf("Datumellenorzes.\nBefejezes ures sorral!\n");
  while(printf("\nDatum (EEEE.HH.NN)? "),
        getline(s,INP)>0)
    if(datume(s)) printf("Ervenyes!\n");
    else printf("Ervenytelen!\n"); }
int datume(const char s[]){
  static int honap[] =
    { 0,31,28,31,30,31,30,31,31,30,31,30,31 };
  int i, ho;
  if(!s[10] && !isdigit(s[4]) && s[4]==s[7]){
    for(i=0; i<10; ++i){
      if(i==4||i==7) ++i;
      if(!isdigit(s[i])) return 0; }
    if((i=atoi(s))>=1){
      honap[2]=28+(!(i%4)&&i%100 || !(i%400));
      if((ho=10*(s[5]-'0')+s[6]-'0')>=1&&ho<=12&&
         (i=10*(s[8]-'0')+s[9]-'0')>=1&&
         i<=honap[ho]) return 1; } }
  return 0; }
int getline(char s[],int lim){
  int c,i;
  for(i=0;i<lim&&(c=getchar())!=EOF&&c!='\n';++i)s[i]=c;
  s[i]='\0';
  while(c!=EOF && c!='\n') c=getchar();
  return(i); }

