/* PELDA25.C: Ketdimenzios tomb letrehozasa dinamikusan. */
#include <stdio.h>
#include <stdlib.h>
typedef long double TIPUS;
typedef TIPUS **OBJEKTUM;
int m=3, n=5; /* Sorok es oszlopok szama. */
int main(void) {
  OBJEKTUM matrix;
  int i, j;
  printf("%d*%d-s, ketdimenzios tomb letrehozasa "
         "dinamikusan.\n", m, n);
  /* A sorok letrehozasa: */
  if(!(matrix=(OBJEKTUM)calloc(m, sizeof(TIPUS *)))) {
    printf("Letrehozhatatlanok a matrix sorai!\n");
    return 1; }
  /* Az oszlopok letrehozasa: */
  for(i = 0; i < m; ++i)
    if(!(matrix[i]=(TIPUS *)malloc(n*sizeof(TIPUS)))) {
      printf("Letrehozhatatlan a matrix %d. sora!\n", i);
      while(--i>=0) free(matrix[i]);
      free(matrix);
      return 1; }
  /* Mesterseges inicializalas: */
  for(i = 0; i < m; ++i)
    for(j = 0; j < n; ++j)
      matrix[i][j] = rand();
  /* Kiiras: */
  printf("A matrix tartalma:\n");
  for(i = 0; i < m; ++i) {
    for(j = 0; j < n; ++j)
      printf("%10.0Lf", matrix[i][j]);
    printf("\n"); }
  /* Az oszlopok felszabaditasa: */
  for(i = m-1; i >= 0; --i) free(matrix[i]);
  /* Sorok felszabaditasa: */
  free(matrix);
  return 0; }

