/* PELDA27.C: rendezes es kereses */
#include<stdio.h>
#include<stdlib.h> /* bsearch, qsort miatt */
#define N 5 /* A tomb elemszama. */
/* Osszehasonlitja a tomb ket elemet. */
int hasonlit(const void* a, const void* b) {
  return *((const int*)a) - *((const int*)b); }
void kiir(const int* t, int n) { 
  int i;
  for(i=0; i<n; i++)
    printf("%d%s", t[i], i==n-1?".\n":", "); }
void keres(int k, const int* t, int n) {
  int* p = (int*)bsearch(&k, t, n, sizeof(int), hasonlit);
  if(p) printf("%d indexe: %d.\n", k, (int)(p-t));
  else printf("%d nincs a tombben.\n", k); }
void main(void) {
  int szamok[N] = { -3, 54, -29, 12, 47 };
  printf("Szamok rendezes elott:\n");
  kiir(szamok, N);
  qsort(szamok, N, sizeof(int), hasonlit);
  printf("Szamok rendezes utan:\n");
  kiir(szamok, N);
  keres(12, szamok, N);
  keres(1234, szamok, N); }

